OSDN Git Service

init.sh: check driver name instead of fb name
[android-x86/device-generic-common.git] / init.sh
diff --git a/init.sh b/init.sh
index c77d483..25f283b 100644 (file)
--- a/init.sh
+++ b/init.sh
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2013-2015 The Android-x86 Open Source Project
+# Copyright (C) 2013-2018 The Android-x86 Open Source Project
 #
 # License: GNU Public License v2 or later
 #
@@ -10,6 +10,18 @@ function set_property()
        [ -n "$DEBUG" ] && echo "$1"="$2" >> /dev/x86.prop
 }
 
+function set_prop_if_empty()
+{
+       [ -z "$(getprop $1)" ] && set_property "$1" "$2"
+}
+
+function rmmod_if_exist()
+{
+       for m in $*; do
+               [ -d /sys/module/$m ] && rmmod $m
+       done
+}
+
 function init_misc()
 {
        # device information
@@ -24,7 +36,28 @@ function init_misc()
 
        # enable sdcardfs if /data is not mounted on tmpfs or 9p
        mount | grep /data\ | grep -qE 'tmpfs|9p'
-       [ $? -ne 0 ] && modprobe sdcardfs
+       [ $? -eq 0 ] && set_prop_if_empty ro.sys.sdcardfs false
+
+       # remove wl if it's not used
+       local wifi
+       if [ -d /sys/class/net/wlan0 ]; then
+               wifi=$(basename `readlink /sys/class/net/wlan0/device/driver`)
+               [ "$wifi" != "wl" ] && rmmod_if_exist wl
+       fi
+
+       # enable virt_wifi if needed
+       local eth=`getprop net.virt_wifi eth0`
+       if [ -d /sys/class/net/$eth -a "$VIRT_WIFI" != "0" ]; then
+               if [ -n "$wifi" -a "$VIRT_WIFI" = "1" ]; then
+                       rmmod_if_exist iwlmvm $wifi
+               fi
+               if [ ! -d /sys/class/net/wlan0 ]; then
+                       ifconfig $eth down
+                       ip link set $eth name wifi_eth
+                       ifconfig wifi_eth up
+                       ip link add link wifi_eth name wlan0 type virt_wifi
+               fi
+       fi
 }
 
 function init_hal_audio()
@@ -33,13 +66,10 @@ function init_hal_audio()
                VirtualBox*|Bochs*)
                        [ -d /proc/asound/card0 ] || modprobe snd-sb16 isapnp=0 irq=5
                        ;;
-               *)
+               TS10*)
+                       set_prop_if_empty hal.audio.out pcmC0D2p
                        ;;
        esac
-
-       if grep -qi "IntelHDMI" /proc/asound/card0/id; then
-               [ -d /proc/asound/card1 ] || set_property ro.hardware.audio.primary hdmi
-       fi
 }
 
 function init_hal_bluetooth()
@@ -50,10 +80,12 @@ function init_hal_bluetooth()
        done
 
        case "$PRODUCT" in
-               T10*TA|HP*Omni*)
+               T100TAF)
+                       set_property bluetooth.interface hci1
+                       ;;
+               T10*TA|M80TA|HP*Omni*)
                        BTUART_PORT=/dev/ttyS1
                        set_property hal.bluetooth.uart.proto bcm
-                       [ -z "$(getprop sleep.state)" ] && set_property sleep.state none
                        ;;
                MacBookPro8*)
                        rmmod b43
@@ -96,7 +128,21 @@ function init_hal_bluetooth()
 
 function init_hal_camera()
 {
-       return
+       case "$UEVENT" in
+               *81EK*)
+                       set_prop_if_empty hal.camera.0 0,0
+                       ;;
+               *e-tabPro*)
+                       set_prop_if_empty hal.camera.0 0,270
+                       set_prop_if_empty hal.camera.2 1,90
+                       ;;
+               *LenovoideapadD330*)
+                       set_prop_if_empty hal.camera.0 0,90
+                       set_prop_if_empty hal.camera.2 1,90
+                       ;;
+               *)
+                       ;;
+       esac
 }
 
 function init_hal_gps()
@@ -111,10 +157,8 @@ function set_drm_mode()
                ET1602*)
                        drm_mode=1366x768
                        ;;
-               VMware*)
-                       [ -n "$video" ] && drm_mode=$video
-                       ;;
                *)
+                       [ -n "$video" ] && drm_mode=$video
                        ;;
        esac
 
@@ -123,6 +167,8 @@ function set_drm_mode()
 
 function init_uvesafb()
 {
+       UVESA_MODE=${UVESA_MODE:-${video%@*}}
+
        case "$PRODUCT" in
                ET2002*)
                        UVESA_MODE=${UVESA_MODE:-1600x900}
@@ -136,23 +182,25 @@ function init_uvesafb()
 
 function init_hal_gralloc()
 {
-       case "$(cat /proc/fb | head -1)" in
-               *virtiodrmfb)
-                       if [ "$HWACCEL" != "0" ]; then
-                               set_property ro.hardware.hwcomposer drm
-                               set_property ro.hardware.gralloc gbm
-                       fi
-                       ;;
-               0*inteldrmfb|0*radeondrmfb|0*nouveaufb|0*svgadrmfb|0*amdgpudrmfb)
+       [ "$VULKAN" = "1" ] && GRALLOC=gbm
+
+       case "$(readlink /sys/class/graphics/fb0/device/driver)" in
+               *virtio_gpu)
+                       HWC=${HWC:-drm}
+                       GRALLOC=${GRALLOC:-gbm}
+                       video=${video:-1280x768}
+                       ;&
+               *i915|*radeon|*nouveau|*vmwgfx|*amdgpu)
                        if [ "$HWACCEL" != "0" ]; then
-                               set_property ro.hardware.gralloc drm
+                               ${HWC:+set_property ro.hardware.hwcomposer $HWC}
+                               set_property ro.hardware.gralloc ${GRALLOC:-drm}
                                set_drm_mode
                        fi
                        ;;
                "")
                        init_uvesafb
                        ;&
-               0*)
+               *)
                        ;;
        esac
 
@@ -165,6 +213,20 @@ function init_hal_hwcomposer()
        return
 }
 
+function init_hal_vulkan()
+{
+       case "$(readlink /sys/class/graphics/fb0/device/driver)" in
+               *i915)
+                       set_property ro.hardware.vulkan android-x86
+                       ;;
+               *amdgpu)
+                       set_property ro.hardware.vulkan radv
+                       ;;
+               *)
+                       ;;
+       esac
+}
+
 function init_hal_lights()
 {
        chown 1000.1000 /sys/class/backlight/*/brightness
@@ -178,6 +240,12 @@ function init_hal_power()
 
        # TODO
        case "$PRODUCT" in
+               HP*Omni*|OEMB|Standard*PC*|Surface*3|T10*TA|VMware*)
+                       set_prop_if_empty sleep.state none
+                       ;;
+               e-tab*Pro)
+                       set_prop_if_empty sleep.state force
+                       ;;
                *)
                        ;;
        esac
@@ -191,7 +259,7 @@ function init_hal_sensors()
 
        local hal_sensors=kbd
        local has_sensors=true
-       case "$(cat $DMIPATH/uevent)" in
+       case "$UEVENT" in
                *Lucid-MWE*)
                        set_property ro.ignore_atkbd 1
                        hal_sensors=hdaps
@@ -248,22 +316,36 @@ function init_hal_sensors()
                        modprobe hdaps
                        hal_sensors=hdaps
                        ;;
-               *i7Stylus*)
-                       set_property ro.iio.accel.y.opt_scale -1
+               *LenovoideapadD330*)
+                       set_property ro.iio.accel.quirks no-trig
+                       set_property ro.iio.accel.order 102
+                       ;&
+               *LINX1010B*)
+                       set_property ro.iio.accel.x.opt_scale -1
                        set_property ro.iio.accel.z.opt_scale -1
                        ;;
-               *ONDATablet*)
+               *i7-WN*)
+                       set_property ro.iio.accel.quirks no-trig
+                       ;&
+               *i7Stylus*)
+                       set_property ro.iio.accel.x.opt_scale -1
+                       ;;
+               *LenovoMIIX320*|*ONDATablet*)
                        set_property ro.iio.accel.order 102
+                       set_property ro.iio.accel.x.opt_scale -1
+                       set_property ro.iio.accel.y.opt_scale -1
                        ;;
+               *SP111-33*)
+                       set_property ro.iio.accel.quirks no-trig
+                       ;&
                *ST70416-6*)
                        set_property ro.iio.accel.order 102
+                       ;;
+               *e-tabPro*|*pnEZpad*|*TECLAST:rntPAD*)
+                       set_property ro.iio.accel.quirks no-trig
                        ;&
-               *Surface.3*|*svnOEMB*|*T305CA*)
+               *T*0*TA*|*M80TA*)
                        set_property ro.iio.accel.y.opt_scale -1
-                       ;&
-               *T10*TA*)
-                       set_property ro.iio.accel.x.opt_scale -1
-                       set_property ro.iio.accel.z.opt_scale -1
                        ;;
                *)
                        has_sensors=false
@@ -273,14 +355,17 @@ function init_hal_sensors()
        # has iio sensor-hub?
        if [ -n "`ls /sys/bus/iio/devices/iio:device* 2> /dev/null`" ]; then
                busybox chown -R 1000.1000 /sys/bus/iio/devices/iio:device*/
+               [ -n "`ls /sys/bus/iio/devices/iio:device*/in_accel_x_raw 2> /dev/null`" ] && has_sensors=true
                hal_sensors=iio
        elif lsmod | grep -q lis3lv02d_i2c; then
                hal_sensors=hdaps
+               has_sensors=true
+       elif [ "$hal_sensors" != "kbd" ]; then
+               has_sensors=true
        fi
 
        set_property ro.hardware.sensors $hal_sensors
-       [ "$hal_sensors" != "kbd" ] && has_sensors=true
-       set_property config.override_forced_orient $has_sensors
+       set_property config.override_forced_orient ${HAS_SENSORS:-$has_sensors}
 }
 
 function create_pointercal()
@@ -296,11 +381,11 @@ function create_pointercal()
 
 function init_tscal()
 {
-       case "$PRODUCT" in
-               ST70416-6*)
+       case "$UEVENT" in
+               *ST70416-6*)
                        modprobe gslx680_ts_acpi
                        ;&
-               T91|T101|ET2002|74499FU|945GSE-ITE8712|CF-19[CDYFGKLP]*)
+               *81EK*|*T91**|*T101*|*ET2002*|*74499FU*|*945GSE-ITE8712*|*CF-19[CDYFGKLP]*|*TECLAST:rntPAD*)
                        create_pointercal
                        return
                        ;;
@@ -322,7 +407,7 @@ function init_tscal()
 
 function init_ril()
 {
-       case "$(cat $DMIPATH/uevent)" in
+       case "$UEVENT" in
                *TEGA*|*2010:svnIntel:*|*Lucid-MWE*)
                        set_property rild.libpath /system/lib/libhuaweigeneric-ril.so
                        set_property rild.libargs "-d /dev/ttyUSB2 -v /dev/ttyUSB1"
@@ -354,6 +439,7 @@ function do_init()
        init_hal_gps
        init_hal_gralloc
        init_hal_hwcomposer
+       init_hal_vulkan
        init_hal_lights
        init_hal_power
        init_hal_sensors
@@ -369,6 +455,8 @@ function do_netconsole()
 
 function do_bootcomplete()
 {
+       hciconfig | grep -q hci || pm disable com.android.bluetooth
+
        init_cpu_governor
 
        [ -z "$(getprop persist.sys.root_access)" ] && setprop persist.sys.root_access 3
@@ -407,6 +495,15 @@ function do_bootcomplete()
                        setkeycodes 0x66 172
                        setkeycodes 0x6b 127
                        ;;
+               Surface*Go)
+                       echo on > /sys/devices/pci0000:00/0000:00:15.1/i2c_designware.1/power/control
+                       ;;
+               VMware*)
+                       pm disable com.android.bluetooth
+                       ;;
+               X80*Power)
+                       set_property power.nonboot-cpu-off 1
+                       ;;
                *)
                        ;;
        esac
@@ -423,13 +520,13 @@ function do_bootcomplete()
                        alsa_amixer -c $c set Headphone on
                        alsa_amixer -c $c set Headphone 100%
                        alsa_amixer -c $c set Speaker 100%
-                       alsa_amixer -c $c set Capture 100%
+                       alsa_amixer -c $c set Capture 80%
                        alsa_amixer -c $c set Capture cap
-                       alsa_amixer -c $c set PCM 100 unmute
+                       alsa_amixer -c $c set PCM 100% unmute
                        alsa_amixer -c $c set SPO unmute
                        alsa_amixer -c $c set IEC958 on
-                       alsa_amixer -c $c set 'Mic Boost' 3
-                       alsa_amixer -c $c set 'Internal Mic Boost' 3
+                       alsa_amixer -c $c set 'Mic Boost' 1
+                       alsa_amixer -c $c set 'Internal Mic Boost' 1
                fi
        done
 
@@ -441,6 +538,7 @@ PATH=/sbin:/system/bin:/system/xbin
 DMIPATH=/sys/class/dmi/id
 BOARD=$(cat $DMIPATH/board_name)
 PRODUCT=$(cat $DMIPATH/product_name)
+UEVENT=$(cat $DMIPATH/uevent)
 
 # import cmdline variables
 for c in `cat /proc/cmdline`; do